function autoc=convergence_diagnostics(A)
% ===================================================
% By Christiane Baumeister and James D. Hamilton (Nov 2014)
% this performs assorted diagnostics on whether the (nA x nmonte) matrix A of nmonte draws
% on an (nA x 1) vector has converged
nA = size(A,1);
nmonte = size(A,2);

% ====================================================
% calculate autocorrelation function
nmax = 50;   % nmax is maximum number of autocorrelations sought
autoc = zeros(nA,nmax);    % autoc will be the autocorrelation function
mu = sum(A')'/nmonte;
Atilde = A - mu*ones(1,nmonte);
var = diag(Atilde*Atilde')/nmonte;
for j=1:nmax
    autoc(:,j) = diag(Atilde(:,j+1:end)*Atilde(:,1:end-j)')'/nmonte;
    autoc(:,j) = autoc(:,j)./var;
end
figure(10)
for i=1:nA
    subplot(nA,1,i)
    plot(1:nmax,autoc(i,:))
    title_a = strcat('Autocorrelation of variable  ',num2str(i));
    axis([1 nmax 0 1])
    title(title_a,'fontsize',10)
end
%'Autocorrelation function is'
%autoc

% ==================================================
% graph parameter draws to check for mixing
figure(11)
for i=1:nA
    subplot(nA,1,i)
    plot(A(i,:)')
    title_a = strcat('Draws of variable  ',num2str(i));
    title(title_a,'fontsize',10)
end
    
    




